%Edward Wong Jun 14, 2011
%edited Jan 22, 2013: fix CFreq for extinct pops
%edited Nov 1, 2013: added regression for Kmodel
%retrieve time series results from workspaces, compute summary statistics,
%and generate response and local density regression parameters

clear
%types of Landscapes to examine:
%Landscapes={'36x36square';'cont10ABbws';'typeAcor24bws';'typeBcor24bws';'typeAstr24bwrs'}; %this order is maintained in subsequent statistical tables as column headings
%Landscapes={'75x75square';'cont10ABbwms';'typeAcor24bwms';'typeBcor24bwms';'typeAstr24bwrms'};
%Landscapes={'typeAcontrolbws';'typeAcor48bws';'typeAcor72bws';'typeAstr24newbwrs';'typeAstr24newshortbwrs';'typeAcor24str24newbwrs'};

%Landscapes={'36x36square';'cont10ABbws';'typeAcor24bws';'typeBcor24bws';'typeAstr24bwrs';'typeAcontrolbws';'typeAcor48bws';'typeAcor72bws';'typeAstr24newbwrs';'typeAstr24newshortbwrs';'typeAcor24str24newbwrs'};
%Landscapes={'36x36square';'cont10ABbws';'typeAcor72bws';'typeAcor48bws';'typeAcor24str24newbwrs';'typeAcor24bws';'typeAcor24longbws';'typeAstr24newshortbwrs';'typeAcor24vlongbws';'typeAstr24newbwrs';'typeAcor24vvlongbws';'typeAstr24vvlongbws';'typeAcontrolbws'};
%'typeAstr24vvlongbws','typeAcor24longbws','typeAcor24vlongbws','typeAcor24vvlongbws'

%Landscapes={'36x36square_';'cont10ABbws_';'typeAcor24bws_';'typeAcor24bwsd_';'typeAcor24longbwsd_';'typeAcor24vlongbwsd_'};
%Landscapes={'36x36square_';'typeAcor24bwsd_';'typeAcor24longbwsd_';'typeAcor24vlongbwsd_';'typeAcor24vvlongbwsd_';'typeAcontrolbws_'};

%Landscapes={'36x36square_';'cont10ABbws_';'typeAcor24bws_';'typeAcor24bwsd_';'typeAcor24longbwsd_';'typeAcor24vlongbwsd_';'typeAcor24vvlongbwsd_';'typeAcontrolbws_'};

%Landscapes={'typeAcontrolbws_';'typeAcor24vvlongbwsd_';'typeAcor24vlongbwsd_';'typeAcor24longbwsd_';'typeAcor24bwsd_';'typeAcor24bws_';'cont10ABbws_';'36x36square_'};
%Landscapes={'typeAcontrolbws_';'typeAcor24vvlongbwsd_';'typeAcor24vlongbwsd_';'typeAcor24longbwsd_';'typeAcor24bwsd_';'cont10ABbws_';'36x36square_'};
%Landscapes={'typeAcontrolbws';'typeAcor24longbwsdID_';'typeAcor24bws';'cont10ABbwsID_';'36x36squareID_'};
Landscapes={'36x36squareID'};


numLands=length(Landscapes);

%regression parameters:
%BoxCox=[-1,-0.5,0,0.5,1,1.5];  %Box-Cox transformations to try for response surface regressions
BoxCox=[1];


%parameters:
Trans=20;	%end gen time for transcient period after random spatial initialization (x50 for run time)
Medium=600;   %end gen time for medium term period (x50)
Long=1000;     %end gen time for long term period (x50)

Start=2;
Trans=3;
MedT=7;
LongT=11;

MapType=0; %0=impermeable boundary, 1=wrap-around toroid

%Interaction kernel 1:
WeightOrigin(1)=1; %interaction kernel weighting of original patch around focal individual
WeightAdjacent(1)=(1-WeightOrigin(1))/6; %interaction kernel weighting of each of 4 adjacent patches around focal individual
Weight2ndNeighbour(1)=(1-WeightOrigin(1))/24; %interaction kernel weighting of each of 8 once-removed patches around focal individual
%check that weights add up to 1:
TotalCellWeights(1)=WeightOrigin(1)+WeightAdjacent(1)*4+Weight2ndNeighbour(1)*8;

%Interaction kernel 2:
WeightOrigin(2)=0.2; %interaction kernel weighting of original patch around focal individual
WeightAdjacent(2)=(1-WeightOrigin(2))/6; %interaction kernel weighting of each of 4 adjacent patches around focal individual
Weight2ndNeighbour(2)=(1-WeightOrigin(2))/24; %interaction kernel weighting of each of 8 once-removed patches around focal individual
%check that weights add up to 1:
TotalCellWeights(2)=WeightOrigin(2)+WeightAdjacent(2)*4+Weight2ndNeighbour(2)*8;

%Interaction kernel 3:
%MPatchSize=[]; %find average size of habitat-scale meta-patch
WeightOrigin(3)=0; %interaction kernel weighting of original patch (and all adjacent patches in habitat-scale meta-patch) around focal individual



%Long term period:
LongDensMean=[];
LongDensMedian=[];
LongDensCv=[];
LongDensMin=[];
LongDensMax=[];

LongCDensMean=[];
LongCDensMedian=[];
LongCDensCv=[];
LongCDensMin=[];
LongCDensMax=[];

LongDDensMean=[];
LongDDensMedian=[];
LongDDensCv=[];
LongDDensMin=[];
LongDDensMax=[];

LongCFreqMean=[];
LongCFreqMedian=[];
LongCFreqStd=[];
LongCFreqMin=[];
LongCFreqMax=[];

LongCCLocalDens=[];
LongCDLocalDens=[];
LongDCLocalDens=[];
LongDDLocalDens=[];

LongCCLocalDens3=[];
LongCDLocalDens3=[];
LongDCLocalDens3=[];
LongDDLocalDens3=[];

LongCCLocalDensVar=[];
LongCDLocalDensVar=[];
LongDCLocalDensVar=[];
LongDDLocalDensVar=[];

LongCCLocalDensVar3=[];
LongCDLocalDensVar3=[];
LongDCLocalDensVar3=[];
LongDDLocalDensVar3=[];

LongCCclustering=[];
LongCDclustering=[];
LongDCclustering=[];
LongDDclustering=[];

LongCCclustering3=[];
LongCDclustering3=[];
LongDCclustering3=[];
LongDDclustering3=[];

LongCMoveMean=[];
LongDMoveMean=[];
LongCMigrateMean=[];
LongDMigrateMean=[];

'Select .mat files containing simulation results in first folder'

Files={};
Paths={};

reply1 = 'a';

while (reply1 == 'a')
    [FileName,PathName]=uigetfile('.mat','Simulation data','MultiSelect','on')
    newFiles=cellstr(FileName);
    newPaths=cellstr(PathName);
    Files=[Files, newFiles];
    for f=1:length(newFiles)
        Paths=[Paths, newPaths];
    end
    reply1 = input('Finished? (enter to continue, a to add files, q to quit): ','s');
    if isempty(reply1)
        reply1 = 'continue';
    end
end

numFiles=length(Files);

if (reply1 ~='q') %continue
    for LandID=1:numLands
        iteration=0;
        Positions=strncmp(Landscapes(LandID),Files,length(Landscapes{LandID})); %find positions of .mat files that belong to landscape type LandID
        for filePos=1:numFiles
            if(Positions(filePos)==1)
                iteration=iteration+1;
                load([Paths{filePos} Files{filePos}]);
                if LandID==1 %catch control habitat, use new map on system (previous runs didn't use meta-patch ID
                    Map=imread([Landscapes{1} '.tif']);
                    Map=flipud(Map);
                end
                %update global temporal probes
                
                %***If population density reaches zero at any point, CF freq
                %is set to equal 1 if last survivor is C, and 0 if last
                %survivor is D, for the duration between that point and
                %the end of time. WARNING: only CFreqMean fixed for this.
                
                
                MoveStates=[];
                MoveStates=SystemStates(4:7,1:100:Long+1);
                
                SystemStates=[];
                LocalDensity=[];
                LocalDensity2=[];
                LocalDensity3=[];
                LocalDensityVar=[];
                LocalDensityVar2=[];
                LocalDensityVar3=[];
                
                
                numCells=0;
                numCors=0;
                for x=1:WorldWidth
                    for y=1:WorldHeight
                        if (Map(y,x)~=255) %check for habitable cell (black=inhabitable=255)
                            numCells=numCells+1;
                            if (Map(y,x)==140 || Map(y,x)==170)
                                numCors=numCors+1;
                            end
                        end
                    end
                end
                
                WeightOrigin(3)=12/(numCells-numCors);
                
                SystemStates(1,:)=sum(sum(GeoDSeries))/numCells;
                SystemStates(2,:)=sum(sum(GeoCSeries))/numCells;
                SystemStates(3,:)=SystemStates(1,:)+SystemStates(2,:);
                
                %long-term period:
                LongStates(1,:)=SystemStates(1,MedT:LongT);
                LongStates(2,:)=SystemStates(2,MedT:LongT);
                LongStates(3,:)=SystemStates(3,MedT:LongT);
                %LongGrowth=percapGrowth(:,MedT:LongT);
                %LongLocalDens=LocalDensity2(:,Medium+1:Long);
                
                LongMove(1,:)=MoveStates(1,MedT:LongT);
                LongMove(2,:)=MoveStates(2,MedT:LongT);
                LongMove(3,:)=MoveStates(3,MedT:LongT);
                LongMove(4,:)=MoveStates(4,MedT:LongT);
                
                %update initial ancillary measurements:
                %compute local densities
                
                for T=1:length(SystemStates(1,:))
                    xcc=cell(3,1); %first index indicates kernel number, second index indicates time
                    xcd=cell(3,1);
                    xdc=cell(3,1);
                    xdd=cell(3,1);
                    xc=zeros(1,12);
                    xd=zeros(1,12);
                    for x=1:WorldWidth
                        for y=1:WorldHeight
                            if Map(y,x)~=255 && Map(y,x)~=140 && Map(y,x)~=170
                                xc(Map(y,x)/10+1)=xc(Map(y,x)/10+1)+GeoCSeries(y,x,T); %add individual count to meta-patch (index)
                                xd(Map(y,x)/10+1)=xd(Map(y,x)/10+1)+GeoDSeries(y,x,T);
                            end
                            for i=1:GeoCSeries(y,x,T) %for each cooperator at the (y,x) location, add xcc and xcd values
                                for k=1:2
                                    xcc{k,1}=[xcc{k,1} (GeoCSeries(y,x,T)-1)*WeightOrigin(k)];
                                    xcd{k,1}=[xcd{k,1} (GeoDSeries(y,x,T))*WeightOrigin(k)];
                                end
                                
                                for dir=1:4 %for local density with extended neighbourhood, weight 4 adjacent cells
                                    [xA,yA] = nextPatchCell(x,y,dir,WorldHeight,WorldWidth,Map,MapType);
                                    for k=1:2
                                        xcc{k,1}(end)=xcc{k,1}(end)+GeoCSeries(yA,xA,T)*WeightAdjacent(k);
                                        xcd{k,1}(end)=xcd{k,1}(end)+GeoDSeries(yA,xA,T)*WeightAdjacent(k);
                                    end
                                end
                                for dir=1:8 %for local density with extended neighbourhood, weight 8 once-removed neighbour cells by remaining fraction and add this weighted number of individuals to Xxtot2
                                    [xA,yA] = next2PatchCell(x,y,dir,WorldHeight,WorldWidth,Map,MapType);
                                    for k=1:2
                                        xcc{k,1}(end)=xcc{k,1}(end)+GeoCSeries(yA,xA,T)*Weight2ndNeighbour(k);
                                        xcd{k,1}(end)=xcd{k,1}(end)+GeoDSeries(yA,xA,T)*Weight2ndNeighbour(k);
                                    end
                                end
                            end
                            for i=1:GeoDSeries(y,x,T) %for each defector at the (y,x) location, add xcc and xcd values
                                for k=1:2
                                    xdc{k,1}=[xdc{k,1} (GeoCSeries(y,x,T))*WeightOrigin(k)];
                                    xdd{k,1}=[xdd{k,1} (GeoDSeries(y,x,T)-1)*WeightOrigin(k)];
                                end
                                
                                for dir=1:4 %for local density with extended neighbourhood, weight 4 adjacent cells
                                    [xA,yA] = nextPatchCell(x,y,dir,WorldHeight,WorldWidth,Map,MapType);
                                    for k=1:2
                                        xdc{k,1}(end)=xdc{k,1}(end)+GeoCSeries(yA,xA,T)*WeightAdjacent(k);
                                        xdd{k,1}(end)=xdd{k,1}(end)+GeoDSeries(yA,xA,T)*WeightAdjacent(k);
                                    end
                                end
                                for dir=1:8 %for local density with extended neighbourhood, weight 8 once-removed neighbour cells by remaining fraction and add this weighted number of individuals to Xxtot2
                                    [xA,yA] = next2PatchCell(x,y,dir,WorldHeight,WorldWidth,Map,MapType);
                                    for k=1:2
                                        xdc{k,1}(end)=xdc{k,1}(end)+GeoCSeries(yA,xA,T)*Weight2ndNeighbour(k);
                                        xdd{k,1}(end)=xdd{k,1}(end)+GeoDSeries(yA,xA,T)*Weight2ndNeighbour(k);
                                    end
                                end
                            end
                        end
                    end
                    
                    
                    for mpatch=1:12
                        xcc{3,1}=[xcc{3,1} ones(1,xc(mpatch))*max(xc(mpatch)-1,0)*WeightOrigin(3)];
                        xcd{3,1}=[xcd{3,1} ones(1,xc(mpatch))*xd(mpatch)*WeightOrigin(3)];
                        xdc{3,1}=[xdc{3,1} ones(1,xd(mpatch))*xc(mpatch)*WeightOrigin(3)];
                        xdd{3,1}=[xdd{3,1} ones(1,xd(mpatch))*max(xd(mpatch)-1,0)*WeightOrigin(3)];
                    end
                    
                    for k=1:3
                        Xcc_mean(k)=mean(xcc{k,1});
                        Xcd_mean(k)=mean(xcd{k,1});
                        Xdc_mean(k)=mean(xdc{k,1});
                        Xdd_mean(k)=mean(xdd{k,1});
                        
                        Xcc_var(k)=var(xcc{k,1});
                        Xcd_var(k)=var(xcd{k,1});
                        Xdc_var(k)=var(xdc{k,1});
                        Xdd_var(k)=var(xdd{k,1});
                    end
                    
                    LocalDensity=[LocalDensity, [Xdd_mean(1) Xdc_mean(1) Xcd_mean(1) Xcc_mean(1)]']; % column # = SAMPLE time T
                    % row 1 = defector local density around defector (Dd)
                    % row 2 = cooperator local density around defector (Cd)
                    % row 3 = defector local density around cooperator (Dc)
                    % row 4 = cooperator local density around cooperator (Cc)
                    LocalDensity2=[LocalDensity2, [Xdd_mean(2) Xdc_mean(2) Xcd_mean(2) Xcc_mean(2)]'];
                    LocalDensity3=[LocalDensity3, [Xdd_mean(3) Xdc_mean(3) Xcd_mean(3) Xcc_mean(3)]'];
                    
                    LocalDensityVar=[LocalDensityVar, [Xdd_var(1) Xdc_var(1) Xcd_var(1) Xcc_var(1)]'];
                    LocalDensityVar2=[LocalDensityVar2, [Xdd_var(2) Xdc_var(2) Xcd_var(2) Xcc_var(2)]'];
                    LocalDensityVar3=[LocalDensityVar3, [Xdd_var(3) Xdc_var(3) Xcd_var(3) Xcc_var(3)]'];
                end
                
                LongLocalDens=LocalDensity(:,MedT:LongT);
                LongLocalDens3=LocalDensity3(:,MedT:LongT);
                LongLocalDensVar=LocalDensityVar(:,MedT:LongT);
                LongLocalDensVar3=LocalDensityVar3(:,MedT:LongT);
                
                
                LongDensMean(iteration,LandID)=mean(LongStates(3,:));
                LongDensMedian(iteration,LandID)=median(LongStates(3,:));
                LongDensCv(iteration,LandID)=std(LongStates(3,:))/LongDensMean(iteration,LandID);
                LongDensMin(iteration,LandID)=min(LongStates(3,:));
                LongDensMax(iteration,LandID)=max(LongStates(3,:));
                
                LongCDensMean(iteration,LandID)=mean(LongStates(2,:));
                LongCDensMedian(iteration,LandID)=median(LongStates(2,:));
                LongCDensCv(iteration,LandID)=std(LongStates(2,:))/LongCDensMean(iteration,LandID);
                LongCDensMin(iteration,LandID)=min(LongStates(2,:));
                LongCDensMax(iteration,LandID)=max(LongStates(2,:));
                
                LongDDensMean(iteration,LandID)=mean(LongStates(1,:));
                LongDDensMedian(iteration,LandID)=median(LongStates(1,:));
                LongDDensCv(iteration,LandID)=std(LongStates(1,:))/LongDDensMean(iteration,LandID);
                LongDDensMin(iteration,LandID)=min(LongStates(1,:));
                LongDDensMax(iteration,LandID)=max(LongStates(1,:));
                
                PosZeroDens=find(SystemStates(3,:),1,'last');
                LastCFreq=0; %last CFreq default to zero
                
                if PosZeroDens<LongT && SystemStates(2,PosZeroDens)>0 %if last surivor is C, set LastCFreq=1
                    LastCFreq=1;
                end
                
                if PosZeroDens<=MedT
                    LongCFreqMean(iteration,LandID)=LastCFreq;
                elseif PosZeroDens<LongT && PosZeroDens>MedT
                    LongCFreqMean(iteration,LandID)=mean(LongStates(2,(1:PosZeroDens-MedT))./LongStates(4,(1:PosZeroDens-MedT)))*(PosZeroDens-MedT)/(LongT-MedT)+LastCFreq*(LongT-PosZeroDens)/(LongT-MedT); %fixed;
                else
                    LongCFreqMean(iteration,LandID)=mean(LongStates(2,:)./LongStates(3,:));
                end
                LongCFreqMedian(iteration,LandID)=median(LongStates(2,:)./LongStates(3,:));
                LongCFreqStd(iteration,LandID)=std(LongStates(2,:)./LongStates(3,:));
                LongCFreqMin(iteration,LandID)=min(LongStates(2,:)./LongStates(3,:));
                LongCFreqMax(iteration,LandID)=max(LongStates(2,:)./LongStates(3,:));
                
                %                 LongCGrowthMean(iteration,LandID)=mean(LongGrowth(2,:));
                %                 LongCGrowthMedian(iteration,LandID)=median(LongGrowth(2,:));
                %                 LongCGrowthStd(iteration,LandID)=std(LongGrowth(2,:));
                %                 LongCGrowthMin(iteration,LandID)=min(LongGrowth(2,:));
                %                 LongCGrowthMax(iteration,LandID)=max(LongGrowth(2,:));
                
                %                 LongDGrowthMean(iteration,LandID)=mean(LongGrowth(1,:));
                %                 LongDGrowthMedian(iteration,LandID)=median(LongGrowth(1,:));
                %                 LongDGrowthStd(iteration,LandID)=std(LongGrowth(1,:));
                %                 LongDGrowthMin(iteration,LandID)=min(LongGrowth(1,:));
                %                 LongDGrowthMax(iteration,LandID)=max(LongGrowth(1,:));
                
                LongCCLocalDens(iteration,LandID)=mean(LongLocalDens(4,:));
                LongCDLocalDens(iteration,LandID)=mean(LongLocalDens(3,:));
                LongDCLocalDens(iteration,LandID)=mean(LongLocalDens(2,:));
                LongDDLocalDens(iteration,LandID)=mean(LongLocalDens(1,:));
                
                LongCCLocalDens3(iteration,LandID)=mean(LongLocalDens3(4,:));
                LongCDLocalDens3(iteration,LandID)=mean(LongLocalDens3(3,:));
                LongDCLocalDens3(iteration,LandID)=mean(LongLocalDens3(2,:));
                LongDDLocalDens3(iteration,LandID)=mean(LongLocalDens3(1,:));
                
                LongCCLocalDensVar(iteration,LandID)=mean(LongLocalDensVar(4,:));
                LongCDLocalDensVar(iteration,LandID)=mean(LongLocalDensVar(3,:));
                LongDCLocalDensVar(iteration,LandID)=mean(LongLocalDensVar(2,:));
                LongDDLocalDensVar(iteration,LandID)=mean(LongLocalDensVar(1,:));
                
                LongCCLocalDensVar3(iteration,LandID)=mean(LongLocalDensVar3(4,:));
                LongCDLocalDensVar3(iteration,LandID)=mean(LongLocalDensVar3(3,:));
                LongDCLocalDensVar3(iteration,LandID)=mean(LongLocalDensVar3(2,:));
                LongDDLocalDensVar3(iteration,LandID)=mean(LongLocalDensVar3(1,:));
                
                LongCCclustering(iteration,LandID)=mean(LongLocalDens(4,:)./LongStates(2,:));
                LongCDclustering(iteration,LandID)=mean(LongLocalDens(3,:)./LongStates(1,:));
                LongDCclustering(iteration,LandID)=mean(LongLocalDens(2,:)./LongStates(2,:));
                LongDDclustering(iteration,LandID)=mean(LongLocalDens(1,:)./LongStates(1,:));
                
                LongCCclustering3(iteration,LandID)=mean(LongLocalDens3(4,:)./LongStates(2,:));
                LongCDclustering3(iteration,LandID)=mean(LongLocalDens3(3,:)./LongStates(1,:));
                LongDCclustering3(iteration,LandID)=mean(LongLocalDens3(2,:)./LongStates(2,:));
                LongDDclustering3(iteration,LandID)=mean(LongLocalDens3(1,:)./LongStates(1,:));
                
                LongCMoveMean(iteration,LandID)=mean(LongMove(1,:));
                LongDMoveMean(iteration,LandID)=mean(LongMove(2,:));
                LongCMigrateMean(iteration,LandID)=mean(LongMove(3,:));
                LongDMigrateMean(iteration,LandID)=mean(LongMove(4,:));
            end
        end
    end
end

save(['m' folder(findstr(folder,'.')+1:end) ' ' int2str(iteration) 'runs LocalDensity1_3']); %save workspace as .mat file
