%Ed 4/17/15 Cij excludes self
%bias correction for within-morph clustering: C'ii=Xii/X'i=Xii/((nj-1)/A)

fModel=[5]; %the focal habitat
numModels=length(fModel);
MovementFolders={'m001 40runs LocalDensity1_3.mat','m0013 40runs LocalDensity1_3.mat','m0016 40runs LocalDensity1_3.mat','m0019 40runs LocalDensity1_3.mat','m0025 40runs LocalDensity1_3.mat','m0032 40runs LocalDensity1_3.mat','m0039 40runs LocalDensity1_3.mat','m005 40runs LocalDensity1_3.mat'};
%MoveRates=[0.1 0.2 0.3 0.4 0.6];
MoveRates=(10.^[0:0.1:0.7])/1000;
LogMoveRates=[0:0.1:0.7];
minRun=40;

Allmtx=[];
All_Move=[];
All_LandID=[];
All_DensMean=[];
All_CFreqMean=[];
All_CCclustering=[];
All_CDclustering=[];
All_DDclustering=[];
All_Xcc=[];
All_Xcd=[];
All_Xdc=[];
All_Xdd=[];


warning('off','all')

%landscapesAll={'36x36squareID';'cont10ABbwsID';'typeAcor24bwsID';'typeAcor24longbwsdID';'typeAcontrolbws'};
%landscapesAll={'typeAcontrolbws';'typeAcor24longbwsdID';'typeAcor24bwsID';'cont10ABbwsID';'36x36squareID'};

landscapesAll={'36x36squareID'};

numNetworks=length(landscapesAll);
MapType=0; %0=impermeable boundary, 1=wrap-around toroid
numCells=[];
numEdge=[];
%choose one of the following Map to define landscape:
for i=1:numNetworks
    Map=imread([landscapesAll{i} '.tif']);
    Map=flipud(Map);
    [WorldHeight,WorldWidth]=size(Map);
    numCells(i)=0;
    numEdge(i)=0;
    for x=1:WorldWidth
        for y=1:WorldHeight
            if (Map(y,x)~=255) %check for inhabitable cell (black=inhabitable=0)
                numCells(i)=numCells(i)+1;
                for direction=1:4
                    [xnext,ynext] = nextPatchCell(x,y,direction,WorldHeight,WorldWidth,Map,MapType); %find coordinates of next cell
                    if(xnext==WorldWidth+1) %chosen direction is impassable, edge
                        numEdge(i)=numEdge(i)+1;
                    end
                end
            end
        end
    end
end
EdgesPerCell=numEdge./numCells;

for moves=1:length(MovementFolders)
    
    load(MovementFolders{moves});
    movement=MoveRates(moves);
    
    Allmtx=[Allmtx meshgrid(1:numModels,1:minRun)];
    All_Move=[All_Move ones(minRun,numModels)*movement];
    All_LandID=[All_LandID meshgrid(EdgesPerCell,1:minRun)];
    All_CDens=LongCDensMean(1:minRun,fModel);
    All_DDens=LongDDensMean(1:minRun,fModel);
    All_DensMean=[All_DensMean LongDensMean(1:minRun,fModel)];
    All_CFreqMean=[All_CFreqMean LongCFreqMean(1:minRun,fModel)];
    All_Cell=ones(minRun,1)*numCells;
    nc_nc_1=All_CDens.*All_Cell./(All_CDens.*All_Cell-1); %correction factor (nc/(nc-1))
    nd_nd_1=All_DDens.*All_Cell./(All_DDens.*All_Cell-1); %correction factor (nd/(nd-1))
    
    All_CCclustering=[All_CCclustering LongCCclustering(1:minRun,fModel).*nc_nc_1];
    All_CDclustering=[All_CDclustering LongCDclustering(1:minRun,fModel)];
    All_DDclustering=[All_DDclustering LongDDclustering(1:minRun,fModel).*nd_nd_1];
    All_Xcc=[All_Xcc LongCCLocalDens(1:minRun,fModel)];
    All_Xcd=[All_Xcd LongCDLocalDens(1:minRun,fModel)];
    All_Xdc=[All_Xdc LongDCLocalDens(1:minRun,fModel)];
    All_Xdd=[All_Xdd LongDDLocalDens(1:minRun,fModel)];
    Rc=(All_Xcc./(All_Xcc+All_Xcd)-All_CFreqMean)./(1-All_CFreqMean);
    Rd=(All_Xdc./(All_Xdc+All_Xdd)-All_CFreqMean)./(-All_CFreqMean);
end

fig1=figure('Color', [1 1 1],'position',[20,50,900,225]);
subplot(1,3,1)
text(-0.15,1.1,'a','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
allDatafit=fitlm(reshape(All_CFreqMean,1,[]),reshape(All_DensMean,1,[]));
%allPlot=plot(allDatafit);
%set(allPlot,'Color','b','Marker','none','LineWidth',1);
numVals=100;
xval = min(All_CFreqMean(:)):(max(All_CFreqMean(:))-min(All_CFreqMean(:)))/(numVals-1):max(All_CFreqMean(:));
[ynew, ci] = predict(allDatafit, xval');
b = [ynew-ci(:,1) ci(:,2)-ynew];
boundedline(xval,ynew',b,'b')
hold on
scatter(reshape(All_CFreqMean,1,[]),reshape(All_DensMean,1,[]),6,'k','filled');
%text(0.05,0.1,{['R^2=' num2str(allDatafit.Rsquared.Ordinary,2)]; ['p=' num2str(allDatafit.Coefficients.pValue(2),2)]},'FontSize',12);
title ''
xlabel 'cooperator frequency (P)'
ylabel 'population density (X)'
legend off
box off

%record cooperation-population slopes & 95% ci by increasing movement rates
CPslopes=[];
CPslopeCI=[];

subplot(1,3,2)
text(-0.15,1.1,'b','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
%colorOrder=[.85 .85 .85; .5 .5 .5; 0 0 0];
for mi=1:length(MovementFolders)
    m2fit=fitlm(reshape(All_CFreqMean(:,mi),1,[]),reshape(All_DensMean(:,mi),1,[]));
    CPslopes(mi)=m2fit.Coefficients.Estimate(2);
    CPslopeCI(mi)=m2fit.Coefficients.SE(2)*1.96;
    CDfit{mi}=m2fit;
    %m2Plot=plot(m2fit);
    %set(m2Plot,'Color','k','Marker','none','LineWidth',1);
    numVals=100;
    xval = min(All_CFreqMean(:,mi)):(max(All_CFreqMean(:,mi))-min(All_CFreqMean(:,mi)))/(numVals-1):max(All_CFreqMean(:,mi));
    [ynew, ci] = predict(m2fit, xval');
    b = [ynew-ci(:,1) ci(:,2)-ynew];
    boundedline(xval,ynew',b,'k')   %yupp = allDatafit.Coefficients.Estimate(1)+allDatafit.Coefficients.SE(1)*1.96+xval.*(allDatafit.Coefficients.Estimate(2)+allDatafit.Coefficients.SE(2)*1.96);
    hold on
    ms=scatter(reshape(All_CFreqMean(:,mi),1,[]),reshape(All_DensMean(:,mi),1,[]),6,'filled');
    MS(mi)=ms;
    %     if mi<4
    %         %text(min(All_CFreqMean(:,mi))-0.27,mean(All_DensMean(:,mi)),['m=' num2str(LogMoveRates(mi)) ', p=' num2str(m2fit.Coefficients.pValue(2),2)],'FontSize',12);
    %         text(min(All_CFreqMean(:,mi))-0.27,mean(All_DensMean(:,mi)),['m=' num2str(LogMoveRates(mi))],'FontSize',12);
    %     else
    %         %text(max(All_CFreqMean(:,mi))+0.032,max(All_DensMean(:,mi)),['m=' num2str(LogMoveRates(mi)) ', p=' num2str(m2fit.Coefficients.pValue(2),2)],'FontSize',12);
    %         text(max(All_CFreqMean(:,mi))+0.032,max(All_DensMean(:,mi)),['m=' num2str(LogMoveRates(mi))],'FontSize',12);
    %     end
    %set(ms,'MarkerFaceColor',colorOrder(mi,:));
end
title ''
xlabel 'cooperator frequency (P)'
ylabel 'population density (X)'
legend off
box off
%legend ([MS(1),MS(2),MS(3)],{'0.2' '0.3' '0.6'})

subplot(1,3,3)
text(-0.15,1.1,'c','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
boundedline([0:0.1:0.7],CPslopes,CPslopeCI,'b')
xlabel 'log movement rate (m)'
ylabel '\DeltaX/\DeltaP'
xlim([0 0.71])


fig2=figure('Color', [1 1 1],'position',[20,50,570,520]);
subplot(2,2,1)
text(-0.15,1.1,'a','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
MoveDensfit=fitlm(reshape(repmat([0:0.1:0.7],40,1),1,[]),reshape(All_DensMean,1,[]))
boundedline([0:0.1:0.7], mean(All_DensMean),std(All_DensMean)*1.96/(length(All_DensMean)^0.5),'b')
%MoveDensPlot=plot(MoveDensfit);
%set(MoveDensPlot,'Color','k','Marker','none','LineWidth',2);
%hold on
%sc=gscatter(repmat([0:0.1:0.7],40,1),All_DensMean);
%set(sc,'Color','k')
%text(0.58,0.1,{['R^2=' num2str(MoveDensfit.Rsquared.Ordinary,2)]; ['p=' num2str(MoveDensfit.Coefficients.pValue(2),2)]},'FontSize',12);
legend off
xlabel 'log movement rate (m)'
ylabel 'population density (X)'
title ''
xlim([0 0.71])

subplot(2,2,2)
text(-0.15,1.1,'b','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
MoveCFreqfit=fitlm(reshape(repmat([0:0.1:0.7],40,1),1,[]),reshape(All_CFreqMean,1,[]))
boundedline([0:0.1:0.7], mean(All_CFreqMean),std(All_CFreqMean)*1.96/(length(All_CFreqMean)^0.5),'b')
%MoveCFreqPlot=plot(MoveCFreqfit);
%set(MoveCFreqPlot,'Color','k','Marker','none','LineWidth',2);
%hold on
%sc=gscatter(repmat([0:0.1:0.7],40,1),All_CFreqMean);
%set(sc,'Color','k')
%text(0,0.1,{['R^2=' num2str(MoveCFreqfit.Rsquared.Ordinary,2)]; ['p=' num2str(MoveCFreqfit.Coefficients.pValue(2),2)]},'FontSize',12);
legend off
xlabel 'log movement rate (m)'
ylabel 'cooperator frequency (P)'
title ''
xlim([0 0.71])

subplot(2,2,3)
text(-0.15,1.1,'c','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
boundedline([0:0.1:0.7], nanmean(Rd),nanstd(Rd)*1.96./((sum(~isnan(Rd))).^0.5),'r')
hold on
boundedline([0:0.1:0.7], nanmean(Rc),nanstd(Rc)*1.96./((sum(~isnan(Rc))).^0.5),'b')
xlabel 'log movement rate (m)'
ylabel 'relatedness (R)'
xlim([0 0.71])

subplot(2,2,4)
text(-0.15,1.1,'d','Units', 'Normalized', 'VerticalAlignment', 'Top','FontSize',14)
boundedline([0:0.1:0.7], nanmean(All_CCclustering),[nanstd(All_CCclustering)*1.96./((sum(~isnan(All_CCclustering))).^0.5)]','b')
%text(0.7,0.7,'C_{cc}','Units', 'Normalized','horizontal','right', 'vertical','bottom','FontSize',12)
hold on
boundedline([0:0.1:0.7], nanmean(All_CDclustering),nanstd(All_CDclustering)*1.96./((sum(~isnan(All_CDclustering))).^0.5),'k')
boundedline([0:0.1:0.7], nanmean(All_DDclustering),[nanstd(All_DDclustering)*1.96./((sum(~isnan(All_DDclustering))).^0.5)]','r')
%refline(0,1)
set(gca, 'YScale', 'log')
xlabel 'log movement rate (m)'
ylabel 'clustering coefficients (C)'
xlim([0 0.71])

[hANCOVA,atabANCOVA,ctabANCOVAm,statsANCOVA]=aoctool(reshape(All_CFreqMean,1,[]),reshape(All_DensMean,1,[]),reshape(repmat(LogMoveRates,40,1),1,[]),0.05,'cooperator frequency','population density','movement rate');