function [GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,WeightOrigin,WeightAdjacent,Weight2ndNeighbour,numCells,Time,sampleTimes,GeoSeriesTimes,WorldHeight,WorldWidth,Map,MapType]=createPatch_SimpleInteract(Map,initC,initD)
% createPatch.m (bacterial cooperation)
% FIRST THING TO RUN BEFORE SIMULATION
% Edward Wong Nov 9, 2011
% edited 1/26/14 to include movement stats in SystemStates
%updated 5/13/14: new simple interaction model

% create world and initialize geography (geographic properties):
%clear

MapType=0; %0=impermeable boundary, 1=wrap-around toroid

%choose one of the following Map to define landscape:

%Map=imread('typeAcor24bws.tif');
%Map=imread('typeBcor24bws.tif');
%Map=imread('typeAstr24bwsv.tif');
%Map=imread('typeAstr24bwrs.tif');
%Map=imread('cont10ABbws.tif');
%Map=imread('Ed.tif');

Map=flipud(Map);

[WorldHeight,WorldWidth]=size(Map);


GeoC=zeros(WorldHeight+1,WorldWidth+1); %  map C=cooperator concentration (Cx)
% note +1 just for plotting using pcolor, last row, column are empty
GeoD=zeros(WorldHeight+1,WorldWidth+1); %  map D=defector concentration (Dx)

GeoCSeries=[];
GeoDSeries=[];
GeoSeriesTimes=[0];
% MigrationCount=[0 0]; %count for defector and cooperator migrations between patches, reset after SimulatPatch is run
% MoveCount=[0 0];

% create tracking data:
% state variables
SystemStates=[]; % column # = SAMPLE time T
        % row 1 = defector global density (D)(avg abundance per cell)
        % row 2 = cooperator global density (C)
        % row 3 = total bacterial density (C+D)
        % row 4 = average defector movement rate
        % row 5 = average cooperator movement rate
        % row 6 = average defector migration rate (between patches)
        % row 7 = average cooperator migration rate

% ancillary variables
LocalDensity=[]; % column # = SAMPLE time T
        % row 1 = defector local density around defector (Dd)
        % row 2 = cooperator local density around defector (Cd)
        % row 3 = defector local density around cooperator (Dc)
        % row 4 = cooperator local density around cooperator (Cc)
%lagLocalDensity=[];
LocalDensity2=[];% same as above but interaction kernel extends beyond origin cell
%lagLocalDensity2=[];
LocalDensity3=[];% same as above but interaction kernel extends beyond origin cell
%lagLocalDensity3=[];
LocalDensityVar=[];
LocalDensityVar2=[];
LocalDensityVar3=[];

        
percapGrowth=zeros(2,1); % column # = SAMPLE time T
        % row 1 = defector per capita growth rate (dD/Ddt(T))=ln(D(T)/D(T-dT))
        % row 2 = cooperator per capita growth rate (dC/Cdt(T))=ln(C(T)/C(T-dT))
        
Time=0;
sampleTimes=[0];

[GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,GeoCSeries,GeoDSeries,WeightOrigin,WeightAdjacent,Weight2ndNeighbour,numCells]=initializePatch_SimpleInteract(GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,GeoCSeries,GeoDSeries,WorldHeight,WorldWidth,Map,MapType,initC,initD);
