function [xnext,ynext] = next2PatchCell(x,y,direction,WorldHeight,WorldWidth,Map,MapType)

%takes current (x,y) positions, and return location of cell in the
%specified direction in the non-immediate neighbourhood ->(xnext, ynext)
%direction: 1,2,3,4,5,6,7,8 (N,NE,E,SE,S,SW,W,NW)

xnext=x;
ynext=y;

%first, assume (x,y) not touching edges of world:

if(direction==1)
    ynext=y+2;
elseif(direction==2)
    xnext=x+1;
    ynext=y+1;
elseif(direction==3)
    xnext=x+2;
elseif(direction==4)
    xnext=x+1;
    ynext=y-1;
elseif(direction==5)
    ynext=y-2;
elseif(direction==6)
    xnext=x-1;
    ynext=y-1;
elseif(direction==7)
    xnext=x-2;
elseif(direction==8)
    xnext=x-1;
    ynext=y+1;
end

if(MapType==1) %if map wrap-around
    %then, check if any xnext values are outside of the world
    if(xnext==WorldWidth+1)
        xnext=1;
    elseif(xnext==WorldWidth+2)
        xnext=2;
    elseif(xnext==0)
        xnext=WorldWidth;
    elseif(xnext==-1)
        xnext=WorldWidth-1;
    end

    %finally, check if any ynext values are outside of the world
    if(ynext==WorldHeight+1)
        ynext=1;
    elseif(ynext==WorldHeight+2)
        ynext=2;
    elseif(ynext==0)
        ynext=WorldHeight;
    elseif(ynext==-1)
        ynext=WorldHeight-1;
    end
else        %map has edges
    if(xnext>WorldWidth||xnext<1||ynext>WorldHeight||ynext<1||Map(ynext,xnext)==255)
        xnext=WorldWidth+1; %this position is assigned to indicate impassable cell
        ynext=WorldHeight+1;
    end
end