%run parallel experiments and save each workspace

%Edward Tekwa May 28, 2012
%modified Feb 20, 12: just run one default scenario
%modified Jan 28, 14: new landscapes include patch ID
%updated 5/13/14: new simple interaction model
%updated 4/12/18: run for multiple movement rates

clear
numCores=8;

parfor process=1:numCores %parameters to vary
    %     rng('shuffle'); %do this for version 2011 to reseed random number generator with current time
    %     %rand('twister',sum(clock)); %do this for earlier versions
    curtime=clock; %generate new seed for each processor
    seed=curtime(6)*now*process;
    rng(seed);
    
    timedata=datestr(now,'yy_mm_dd_HHMM');
    
    simLength=10; %10 %number of times to run runPatch (# times to save visual snapshots per simulation): see runPatch for runTime per call
    runTime=100; %100; %this just indicates how long the simulation runs for, does not affect time series qualitatively
    iterations=40; %number of time series to obtain from a single parameter set
      
    landscapesCur={'36x36squareID'};
    initC=0.1;
    initD=0.1;
    
    b=0.2; %birth rate 0.15 0.25
    d=0.1; %death rate
    k=0.1; %competition coefficient 0.05 0.15
    a=0.05; %benefit 0.025 0.075
    c=0.01; %cost 0.005 0.015
    moveVar=(10.^[0:0.1:0.7])/1000; %movement rate (probability of moving 100 times in 1 geo time step)
    %moveVar=1;
    m=moveVar(process);
    
    Parameters=[b,d,k,a,c,m];
    ParamNames={'Birth b','Death d','Compete k','Help a','Cost c','Move m'};
    %ParamNames=['SimpleInteract']; %folder name
    parameter=6;
    
    fig1=figure ('Color', [1 1 1]);
    set(fig1,'position',[20,50,800,1200]);
    runSeries_SimpleInteract(timedata,parameter,Parameters,ParamNames{parameter},simLength,runTime,iterations,landscapesCur,initC,initD);
    
end
%

%matlabpool close