function []=runSeries_SimpleInteract(timedata,parameter,Parameters,name,simLength,runTime,iterations,landscapes,initC,initD)

%run a series of experiments and save each workspace

%Edward Wong Nov 25, 2011
%updated 5/13/14: new simple interaction model

%clear
%initialize variables
%rng('shuffle'); %do this for version 2011 to reseed random number generator with current time
%rand('twister',sum(clock)); %do this for earlier versions
global avgC
global avgD
global CextinctT
global DextinctT

if parameter==6
    folder=['Simulation_' timedata '_' name num2str(Parameters(parameter),2)];
elseif parameter==7
    folder=['Simulation_' timedata '_parameter_' name '_values' sprintf(' %.2g',Parameters)];
else
    folder=['Simulation_' timedata '_parameter_' name '_value' num2str(Parameters(parameter),2)];
end
%folder=['Simulation_' datestr(now,'yy_mm_dd_HHMM')];

%check if parameter combo has already be initiated
curDir=dir;
curFolders=curDir([curDir.isdir]');
oldFolder=[];
for fN=1:length(curFolders)
    if contains(curFolders(fN).name,['_parameter_' name '_values' sprintf(' %.2g',Parameters)])
        oldFolder=curFolders(fN).name;
    end
end
if isempty(oldFolder) %didn't find existing folder with the current parameter combo
    mkdir(folder);
else
    folder=oldFolder;
end

curFiles=dir(folder); %files in current parameter combo folder
%simLength=18; %number of times to run runPatch (# times to save visual snapshots per simulation): see runPatch for runTime per call
%iterations=100;
%landscapes={'36x36square';'typeAcor24bws';'typeBcor24bws';'typeAstr24bwrs';'cont10ABbws'};


%numLands=length(landscapes);

%run sample simulation
% Map=imread('36x36square.tif');
% createPatch
% hgsave([folder '/kernels']);
%
% reply1 = input('Kernels okay? (enter to continue, other key then enter to escape): ','s');
% if isempty(reply1)
%     reply1 = 'continue501';
% end
%
% if (reply1=='continue501')
%     plotS
%
%     reply2 = input('Resize figure window before simulation (enter to continue, other key then enter to escape): ','s');
%     if isempty(reply2)
%         reply2 = 'continue501';
%     end
%
%     if (reply2=='continue501')

numLands=length(landscapes);
for m=1:iterations
    for L=1:numLands
        if isempty(curFiles(contains({curFiles.name},[landscapes{L} '_run' int2str(m)]))) %only run if iteration does not exist
            %clear GeoC GeoD GeoS IndivTable SystemStates LocalDensity LocalDensity2 LocalDensity3 percapGrowth Time sampleTimes;
            Map=imread([landscapes{L} '.tif']);
            [GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,WeightOrigin,WeightAdjacent,Weight2ndNeighbour,numCells,Time,sampleTimes,GeoSeriesTimes,WorldHeight,WorldWidth,Map,MapType]=createPatch_SimpleInteract(Map,initC,initD);
            stopping=0;
            for n=1:simLength
                [GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,Time,sampleTimes,GeoSeriesTimes,stopping]=runPatch_SimpleInteract(runTime,GeoC,GeoD,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,Parameters,WeightOrigin,WeightAdjacent,Weight2ndNeighbour,Time,sampleTimes,GeoSeriesTimes,numCells,WorldHeight,WorldWidth,Map,MapType);
                if stopping == 1
                    break
                end
                %hgsave([folder '/' landscapes{L} '_run' int2str(m) '_time' int2str(n)]); %save simulation snapshot as .fig file
                %savefig(folder, landscapes, L, m, n);
            end
            savemat_SimpleInteract(folder, landscapes, L, m, Parameters,Map,WorldHeight,WorldWidth,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,sampleTimes,GeoSeriesTimes);
            %save([folder '/' landscapes{L} '_run' int2str(m)]); %save workspace as .mat file
            %                 if stopping == 0
            %                     %savemat_many(folder, landscapes, L, m, Parameters,Map,WorldHeight,WorldWidth,SystemStates,LocalDensity,LocalDensity2,LocalDensity3,LocalDensityVar,LocalDensityVar2,LocalDensityVar3,percapGrowth,GeoCSeries,GeoDSeries,GeoSSeries,sampleTimes,GeoSeriesTimes);
            %                     avgC = mean(SystemStates(2,:));
            %                     avgD = mean(SystemStates(1,:));
            %                     CextinctT = length(SystemStates);
            %                     DextinctT = length(SystemStates);
            %                 end
        end
    end
end
%     end
% end